#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#define	REG_WYRM	"Software\\WyrmSoft"
#define	REG_WYRM_SUB	"Rattler"
#define	REG_SFWR	"Software"
#define	REG_SFWR_SUB	"WyrmSoft"

int
main( void ) {
   LONG		lrc;
   DWORD	nSubKeys;
   DWORD	nValues;
   HKEY		hKey;


   printf( "Attempting to delete Rattler configuration information...\n" );

   // Open HKEY_LOCAL_MACHINE\Software\WyrmSoft
   lrc = RegOpenKeyEx( HKEY_LOCAL_MACHINE, REG_WYRM, 0,
                       KEY_ALL_ACCESS, &hKey );
   if( lrc != ERROR_SUCCESS ) {
      printf( "Error opening registry key: HKEY_LOCAL_MACHINE\\%s\n",
              REG_WYRM );
      return( -1 );
   }

   // Delete HKEY_LOCAL_MACHINE\Software\WyrmSoft\Rattler
   lrc = RegDeleteKey( hKey, REG_WYRM_SUB );
   if( lrc != ERROR_SUCCESS ) {
      printf( "Error deleting registry key: HKEY_LOCAL_MACHINE\\%s\\%s\n",
              REG_WYRM, REG_WYRM_SUB );
      return( -1 );
   }


   // If there are no subkeys/values, delete the WyrmSoft Key
   lrc = RegQueryInfoKey( hKey, NULL, NULL, NULL, &nSubKeys, NULL, NULL,
                          &nValues, NULL, NULL, NULL, NULL );
   if( ERROR_SUCCESS == lrc && 0 == nSubKeys && 0 == nValues ) {
      lrc = RegOpenKeyEx( HKEY_LOCAL_MACHINE, REG_SFWR, 0,
                          KEY_ALL_ACCESS, &hKey );
      if( ERROR_SUCCESS == lrc ) RegDeleteKey( hKey, REG_SFWR_SUB );
   }

   printf( "Rattler configuration deleted" );

   return( 0 );
}
